/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SWSInteraction.impl;

import SWSInteraction.Effect;
import SWSInteraction.Grounding;
import SWSInteraction.Input;
import SWSInteraction.Interface;
import SWSInteraction.Output;
import SWSInteraction.Plan;
import SWSInteraction.Precondition;
import SWSInteraction.RegistrationRole;
import SWSInteraction.Role;
import SWSInteraction.SSMatchmakerAgent;
import SWSInteraction.SS_AgreementPlan;
import SWSInteraction.SS_ExecutorPlan;
import SWSInteraction.SS_FinderPlan;
import SWSInteraction.SS_RegisterPlan;
import SWSInteraction.SWS;
import SWSInteraction.SWSInteractionPackage;
import SWSInteraction.SWSInteractionViewpoint;
import SWSInteraction.SemanticWebAgent;
import SWSInteraction.WebService;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Viewpoint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsPlan <em>Contains Plan</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsSSRegisterPlan <em>Contains SS Register Plan</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsSSFinderPlan <em>Contains SS Finder Plan</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsSSAgreementPlan <em>Contains SS Agreement Plan</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsExecutorPlan <em>Contains Executor Plan</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsSWAgent <em>Contains SW Agent</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsSSMatchmakerAgent <em>Contains SS Matchmaker Agent</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsRole <em>Contains Role</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsInterface <em>Contains Interface</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsProcess <em>Contains Process</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsGrounding <em>Contains Grounding</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsInput <em>Contains Input</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsOutput <em>Contains Output</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsPrecondition <em>Contains Precondition</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsEffect <em>Contains Effect</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsWebService <em>Contains Web Service</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsSWS <em>Contains SWS</em>}</li>
 *   <li>{@link SWSInteraction.impl.SWSInteractionViewpointImpl#getContainsRegistrationRole <em>Contains Registration Role</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SWSInteractionViewpointImpl extends EObjectImpl implements SWSInteractionViewpoint {
	/**
	 * The cached value of the '{@link #getContainsPlan() <em>Contains Plan</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsPlan()
	 * @generated
	 * @ordered
	 */
	protected EList<Plan> containsPlan;

	/**
	 * The cached value of the '{@link #getContainsSSRegisterPlan() <em>Contains SS Register Plan</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsSSRegisterPlan()
	 * @generated
	 * @ordered
	 */
	protected EList<SS_RegisterPlan> containsSSRegisterPlan;

	/**
	 * The cached value of the '{@link #getContainsSSFinderPlan() <em>Contains SS Finder Plan</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsSSFinderPlan()
	 * @generated
	 * @ordered
	 */
	protected EList<SS_FinderPlan> containsSSFinderPlan;

	/**
	 * The cached value of the '{@link #getContainsSSAgreementPlan() <em>Contains SS Agreement Plan</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsSSAgreementPlan()
	 * @generated
	 * @ordered
	 */
	protected EList<SS_AgreementPlan> containsSSAgreementPlan;

	/**
	 * The cached value of the '{@link #getContainsExecutorPlan() <em>Contains Executor Plan</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsExecutorPlan()
	 * @generated
	 * @ordered
	 */
	protected EList<SS_ExecutorPlan> containsExecutorPlan;

	/**
	 * The cached value of the '{@link #getContainsSWAgent() <em>Contains SW Agent</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsSWAgent()
	 * @generated
	 * @ordered
	 */
	protected EList<SemanticWebAgent> containsSWAgent;

	/**
	 * The cached value of the '{@link #getContainsSSMatchmakerAgent() <em>Contains SS Matchmaker Agent</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsSSMatchmakerAgent()
	 * @generated
	 * @ordered
	 */
	protected EList<SSMatchmakerAgent> containsSSMatchmakerAgent;

	/**
	 * The cached value of the '{@link #getContainsRole() <em>Contains Role</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsRole()
	 * @generated
	 * @ordered
	 */
	protected EList<Role> containsRole;

	/**
	 * The cached value of the '{@link #getContainsInterface() <em>Contains Interface</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsInterface()
	 * @generated
	 * @ordered
	 */
	protected EList<Interface> containsInterface;

	/**
	 * The cached value of the '{@link #getContainsProcess() <em>Contains Process</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsProcess()
	 * @generated
	 * @ordered
	 */
	protected EList<SWSInteraction.Process> containsProcess;

	/**
	 * The cached value of the '{@link #getContainsGrounding() <em>Contains Grounding</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsGrounding()
	 * @generated
	 * @ordered
	 */
	protected EList<Grounding> containsGrounding;

	/**
	 * The cached value of the '{@link #getContainsInput() <em>Contains Input</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsInput()
	 * @generated
	 * @ordered
	 */
	protected EList<Input> containsInput;

	/**
	 * The cached value of the '{@link #getContainsOutput() <em>Contains Output</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsOutput()
	 * @generated
	 * @ordered
	 */
	protected EList<Output> containsOutput;

	/**
	 * The cached value of the '{@link #getContainsPrecondition() <em>Contains Precondition</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsPrecondition()
	 * @generated
	 * @ordered
	 */
	protected EList<Precondition> containsPrecondition;

	/**
	 * The cached value of the '{@link #getContainsEffect() <em>Contains Effect</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsEffect()
	 * @generated
	 * @ordered
	 */
	protected EList<Effect> containsEffect;

	/**
	 * The cached value of the '{@link #getContainsWebService() <em>Contains Web Service</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsWebService()
	 * @generated
	 * @ordered
	 */
	protected EList<WebService> containsWebService;

	/**
	 * The cached value of the '{@link #getContainsSWS() <em>Contains SWS</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsSWS()
	 * @generated
	 * @ordered
	 */
	protected EList<SWS> containsSWS;

	/**
	 * The cached value of the '{@link #getContainsRegistrationRole() <em>Contains Registration Role</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainsRegistrationRole()
	 * @generated
	 * @ordered
	 */
	protected EList<RegistrationRole> containsRegistrationRole;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SWSInteractionViewpointImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SWSInteractionPackage.Literals.SWS_INTERACTION_VIEWPOINT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Plan> getContainsPlan() {
		if (containsPlan == null) {
			containsPlan = new EObjectContainmentEList<Plan>(Plan.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PLAN);
		}
		return containsPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SS_RegisterPlan> getContainsSSRegisterPlan() {
		if (containsSSRegisterPlan == null) {
			containsSSRegisterPlan = new EObjectContainmentEList<SS_RegisterPlan>(SS_RegisterPlan.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_REGISTER_PLAN);
		}
		return containsSSRegisterPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SS_FinderPlan> getContainsSSFinderPlan() {
		if (containsSSFinderPlan == null) {
			containsSSFinderPlan = new EObjectContainmentEList<SS_FinderPlan>(SS_FinderPlan.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_FINDER_PLAN);
		}
		return containsSSFinderPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SS_AgreementPlan> getContainsSSAgreementPlan() {
		if (containsSSAgreementPlan == null) {
			containsSSAgreementPlan = new EObjectContainmentEList<SS_AgreementPlan>(SS_AgreementPlan.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_AGREEMENT_PLAN);
		}
		return containsSSAgreementPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SS_ExecutorPlan> getContainsExecutorPlan() {
		if (containsExecutorPlan == null) {
			containsExecutorPlan = new EObjectContainmentEList<SS_ExecutorPlan>(SS_ExecutorPlan.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EXECUTOR_PLAN);
		}
		return containsExecutorPlan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SemanticWebAgent> getContainsSWAgent() {
		if (containsSWAgent == null) {
			containsSWAgent = new EObjectContainmentEList<SemanticWebAgent>(SemanticWebAgent.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SW_AGENT);
		}
		return containsSWAgent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SSMatchmakerAgent> getContainsSSMatchmakerAgent() {
		if (containsSSMatchmakerAgent == null) {
			containsSSMatchmakerAgent = new EObjectContainmentEList<SSMatchmakerAgent>(SSMatchmakerAgent.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_MATCHMAKER_AGENT);
		}
		return containsSSMatchmakerAgent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Role> getContainsRole() {
		if (containsRole == null) {
			containsRole = new EObjectContainmentEList<Role>(Role.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_ROLE);
		}
		return containsRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Interface> getContainsInterface() {
		if (containsInterface == null) {
			containsInterface = new EObjectContainmentEList<Interface>(Interface.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INTERFACE);
		}
		return containsInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SWSInteraction.Process> getContainsProcess() {
		if (containsProcess == null) {
			containsProcess = new EObjectContainmentEList<SWSInteraction.Process>(SWSInteraction.Process.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PROCESS);
		}
		return containsProcess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Grounding> getContainsGrounding() {
		if (containsGrounding == null) {
			containsGrounding = new EObjectContainmentEList<Grounding>(Grounding.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_GROUNDING);
		}
		return containsGrounding;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Input> getContainsInput() {
		if (containsInput == null) {
			containsInput = new EObjectContainmentEList<Input>(Input.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INPUT);
		}
		return containsInput;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Output> getContainsOutput() {
		if (containsOutput == null) {
			containsOutput = new EObjectContainmentEList<Output>(Output.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_OUTPUT);
		}
		return containsOutput;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Precondition> getContainsPrecondition() {
		if (containsPrecondition == null) {
			containsPrecondition = new EObjectContainmentEList<Precondition>(Precondition.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PRECONDITION);
		}
		return containsPrecondition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Effect> getContainsEffect() {
		if (containsEffect == null) {
			containsEffect = new EObjectContainmentEList<Effect>(Effect.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EFFECT);
		}
		return containsEffect;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<WebService> getContainsWebService() {
		if (containsWebService == null) {
			containsWebService = new EObjectContainmentEList<WebService>(WebService.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_WEB_SERVICE);
		}
		return containsWebService;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SWS> getContainsSWS() {
		if (containsSWS == null) {
			containsSWS = new EObjectContainmentEList<SWS>(SWS.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SWS);
		}
		return containsSWS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RegistrationRole> getContainsRegistrationRole() {
		if (containsRegistrationRole == null) {
			containsRegistrationRole = new EObjectContainmentEList<RegistrationRole>(RegistrationRole.class, this, SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_REGISTRATION_ROLE);
		}
		return containsRegistrationRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PLAN:
				return ((InternalEList<?>)getContainsPlan()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_REGISTER_PLAN:
				return ((InternalEList<?>)getContainsSSRegisterPlan()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_FINDER_PLAN:
				return ((InternalEList<?>)getContainsSSFinderPlan()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_AGREEMENT_PLAN:
				return ((InternalEList<?>)getContainsSSAgreementPlan()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EXECUTOR_PLAN:
				return ((InternalEList<?>)getContainsExecutorPlan()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SW_AGENT:
				return ((InternalEList<?>)getContainsSWAgent()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_MATCHMAKER_AGENT:
				return ((InternalEList<?>)getContainsSSMatchmakerAgent()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_ROLE:
				return ((InternalEList<?>)getContainsRole()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INTERFACE:
				return ((InternalEList<?>)getContainsInterface()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PROCESS:
				return ((InternalEList<?>)getContainsProcess()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_GROUNDING:
				return ((InternalEList<?>)getContainsGrounding()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INPUT:
				return ((InternalEList<?>)getContainsInput()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_OUTPUT:
				return ((InternalEList<?>)getContainsOutput()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PRECONDITION:
				return ((InternalEList<?>)getContainsPrecondition()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EFFECT:
				return ((InternalEList<?>)getContainsEffect()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_WEB_SERVICE:
				return ((InternalEList<?>)getContainsWebService()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SWS:
				return ((InternalEList<?>)getContainsSWS()).basicRemove(otherEnd, msgs);
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_REGISTRATION_ROLE:
				return ((InternalEList<?>)getContainsRegistrationRole()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PLAN:
				return getContainsPlan();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_REGISTER_PLAN:
				return getContainsSSRegisterPlan();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_FINDER_PLAN:
				return getContainsSSFinderPlan();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_AGREEMENT_PLAN:
				return getContainsSSAgreementPlan();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EXECUTOR_PLAN:
				return getContainsExecutorPlan();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SW_AGENT:
				return getContainsSWAgent();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_MATCHMAKER_AGENT:
				return getContainsSSMatchmakerAgent();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_ROLE:
				return getContainsRole();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INTERFACE:
				return getContainsInterface();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PROCESS:
				return getContainsProcess();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_GROUNDING:
				return getContainsGrounding();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INPUT:
				return getContainsInput();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_OUTPUT:
				return getContainsOutput();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PRECONDITION:
				return getContainsPrecondition();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EFFECT:
				return getContainsEffect();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_WEB_SERVICE:
				return getContainsWebService();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SWS:
				return getContainsSWS();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_REGISTRATION_ROLE:
				return getContainsRegistrationRole();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PLAN:
				getContainsPlan().clear();
				getContainsPlan().addAll((Collection<? extends Plan>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_REGISTER_PLAN:
				getContainsSSRegisterPlan().clear();
				getContainsSSRegisterPlan().addAll((Collection<? extends SS_RegisterPlan>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_FINDER_PLAN:
				getContainsSSFinderPlan().clear();
				getContainsSSFinderPlan().addAll((Collection<? extends SS_FinderPlan>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_AGREEMENT_PLAN:
				getContainsSSAgreementPlan().clear();
				getContainsSSAgreementPlan().addAll((Collection<? extends SS_AgreementPlan>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EXECUTOR_PLAN:
				getContainsExecutorPlan().clear();
				getContainsExecutorPlan().addAll((Collection<? extends SS_ExecutorPlan>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SW_AGENT:
				getContainsSWAgent().clear();
				getContainsSWAgent().addAll((Collection<? extends SemanticWebAgent>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_MATCHMAKER_AGENT:
				getContainsSSMatchmakerAgent().clear();
				getContainsSSMatchmakerAgent().addAll((Collection<? extends SSMatchmakerAgent>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_ROLE:
				getContainsRole().clear();
				getContainsRole().addAll((Collection<? extends Role>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INTERFACE:
				getContainsInterface().clear();
				getContainsInterface().addAll((Collection<? extends Interface>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PROCESS:
				getContainsProcess().clear();
				getContainsProcess().addAll((Collection<? extends SWSInteraction.Process>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_GROUNDING:
				getContainsGrounding().clear();
				getContainsGrounding().addAll((Collection<? extends Grounding>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INPUT:
				getContainsInput().clear();
				getContainsInput().addAll((Collection<? extends Input>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_OUTPUT:
				getContainsOutput().clear();
				getContainsOutput().addAll((Collection<? extends Output>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PRECONDITION:
				getContainsPrecondition().clear();
				getContainsPrecondition().addAll((Collection<? extends Precondition>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EFFECT:
				getContainsEffect().clear();
				getContainsEffect().addAll((Collection<? extends Effect>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_WEB_SERVICE:
				getContainsWebService().clear();
				getContainsWebService().addAll((Collection<? extends WebService>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SWS:
				getContainsSWS().clear();
				getContainsSWS().addAll((Collection<? extends SWS>)newValue);
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_REGISTRATION_ROLE:
				getContainsRegistrationRole().clear();
				getContainsRegistrationRole().addAll((Collection<? extends RegistrationRole>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PLAN:
				getContainsPlan().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_REGISTER_PLAN:
				getContainsSSRegisterPlan().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_FINDER_PLAN:
				getContainsSSFinderPlan().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_AGREEMENT_PLAN:
				getContainsSSAgreementPlan().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EXECUTOR_PLAN:
				getContainsExecutorPlan().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SW_AGENT:
				getContainsSWAgent().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_MATCHMAKER_AGENT:
				getContainsSSMatchmakerAgent().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_ROLE:
				getContainsRole().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INTERFACE:
				getContainsInterface().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PROCESS:
				getContainsProcess().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_GROUNDING:
				getContainsGrounding().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INPUT:
				getContainsInput().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_OUTPUT:
				getContainsOutput().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PRECONDITION:
				getContainsPrecondition().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EFFECT:
				getContainsEffect().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_WEB_SERVICE:
				getContainsWebService().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SWS:
				getContainsSWS().clear();
				return;
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_REGISTRATION_ROLE:
				getContainsRegistrationRole().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PLAN:
				return containsPlan != null && !containsPlan.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_REGISTER_PLAN:
				return containsSSRegisterPlan != null && !containsSSRegisterPlan.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_FINDER_PLAN:
				return containsSSFinderPlan != null && !containsSSFinderPlan.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_AGREEMENT_PLAN:
				return containsSSAgreementPlan != null && !containsSSAgreementPlan.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EXECUTOR_PLAN:
				return containsExecutorPlan != null && !containsExecutorPlan.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SW_AGENT:
				return containsSWAgent != null && !containsSWAgent.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SS_MATCHMAKER_AGENT:
				return containsSSMatchmakerAgent != null && !containsSSMatchmakerAgent.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_ROLE:
				return containsRole != null && !containsRole.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INTERFACE:
				return containsInterface != null && !containsInterface.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PROCESS:
				return containsProcess != null && !containsProcess.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_GROUNDING:
				return containsGrounding != null && !containsGrounding.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_INPUT:
				return containsInput != null && !containsInput.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_OUTPUT:
				return containsOutput != null && !containsOutput.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_PRECONDITION:
				return containsPrecondition != null && !containsPrecondition.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_EFFECT:
				return containsEffect != null && !containsEffect.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_WEB_SERVICE:
				return containsWebService != null && !containsWebService.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_SWS:
				return containsSWS != null && !containsSWS.isEmpty();
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT__CONTAINS_REGISTRATION_ROLE:
				return containsRegistrationRole != null && !containsRegistrationRole.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //SWSInteractionViewpointImpl
